#ifndef _TFEVENTLIST_H_
#define _TFEVENTLIST_H_

#include <iostream>
#include <iomanip>
#include <fstream>
#include <vector>
#include <map>

#include "aux/TF/TFGen.h"
#include "aux/TF/TFEvent.h"
#include "aux/AuxString.h"
#include "aux/Report.h"

#include "aux/SpyBuffer/EventFragmentTrackFTKPacket.h"

#include "ftkcommon/EventFragmentCollection.h"

namespace daq {
  namespace ftk {
    /*!\brief A list of multiple events
     *
     * This class includes the functions necessary for parsing different input formats.
     */
    class TFEventList
    {
    public:
      TFEventList( const std::string& _name = "Events" );
      ~TFEventList();

      unsigned int getNEvents() const;

      std::string getName() const;

      /*! \brief Get event at index ievent
       *
       * \param ievent index of the event
       *
       * \return event at index ievent
       */
      TFEvent* getEvent(unsigned int ievent) const;

      /*! \brief Compare this event list to another event list.
       *
       * Check each event in list against the corresponding (by position
       * in list) event in the other list.
       *
       * \return true if all good
       */
      bool compareAllEvents(TFEventList *other, bool split_sectors);

      /*! \brief Build from DOOutput event collections
       *
       * \param eventCollections Collection of event fragmets
       */
      bool buildFromDOOutputEventCollections(const std::vector<EventFragmentCollection*>& eventCollections, bool debug, int proc);

      /*! \brief Build from track event collections
       *
       * \param eventCollections Collection of event fragmets
       */
      void buildFromTrackEventCollections(const std::vector<EventFragmentCollection*>& eventCollections);

      /*! \brief Load event by parsing a file
       *
       * Method to parse the file is based on the file name.
       *
       * \todo come up with a better method once we have stable code
       *
       * \param path Path to the file
       */
      void buildFromFile(const std::string& path);

      /*!
       * Build from the Buffer Logic Spy buffer output
       */
      void buildFromBLSpyBufferFile(const std::string& path );

      /*!
       * Build using the output from DOParser.py in VMEScripts
       */
      void buildFromDOParserFile(const std::string& path );

      /*!
       * Build using the DOOutputFile generated by VMEScripts
       * (can't remember which script)
       */
      void buildFromDOOutputFile(const std::string& path);

      void buildFromTFVector(std::vector<u_int> &content);

      void buildFromBLMap(std::map<u_int, std::vector<u_int> >& content);

      /*! \brief Return events as EventFragmentTrackFTKPacket objects
       *
       * \return List of events as EventFragmentTrackFTKPacket objects
       */
      std::vector<EventFragment*> dumpToEventFragments() const;

    private:
  
      std::string name;
      std::vector<TFEvent*> vec_events;

      /*! \brief Read line with error checking.
       * 
       * Read line while making sure that the file is open and that
       * the line is not empty
       *
       * \param f file handle
       * \param line string reference where to save the next line
       *
       * \return true if reading went ok
       */
      bool safe_getline( std::ifstream &f , std::string &line );

    };
  } // namespace ftk
} // namespace daq

#endif
